/*
 * libsal/syslimit/priority.c
 * Support for get/setpriority system calls
 */

/*
 * Author:
 * Stuart Herbert,
 * Academic Computng Services, The University of Sheffield
 * Email: S.Herbert@sheffield.ac.uk
 */

#include <libsal/license.h>
#include <libsal/syslimit/internal.h>
#include <libsal/proto.h>
#include <libsal/defines.h>

#if	HAS_PRIORITY_LIMITS
#include <sys/time.h>
#include <sys/resource.h>
#endif

int sal_syslimit_getpriority(sal_syslimit *pstLimitArg)
{
#if	HAS_PRIORITY_LIMITS
  TEST_ARG(pstLimitArg != NULL, 1);
  
  pstLimitArg->stLimitValue.iValue = getpriority(PRIO_PROCESS, 0);
  return 1;
#else
  return 0;
#endif
}

int sal_syslimit_setpriority(sal_syslimit *pstLimitArg)
{
#if	HAS_PRIORITY_LIMITS
  TEST_ARG(pstLimitArg != NULL, 1);
  
  if ((setpriority(PRIO_PROCESS, 0, pstLimitArg->stLimitValue.iValue)) == -1)
    return 0;
  else
    return 1;
#else
  return 0;
#endif
}
